import request from '@/utils/request';
import type {ApiResult, PageResult} from '@/api';
import type {FinalSettleLost, FinalSettleLostParam} from './model';

/**
 * 分页查询结算
 */
export async function pageFinalSettleLost(params: FinalSettleLostParam) {
  const res = await request.get<ApiResult<PageResult<FinalSettleLost>>>(
    '/tower/tower-contract-final-settle-lost/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询合同列表
 */
export async function listFinalSettleLost(params?: FinalSettleLostParam) {
  const res = await request.get<ApiResult<FinalSettleLost[]>>(
    '/tower/tower-contract-final-settle-lost',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询合同
 */
export async function getFinalSettleLost(id: number) {
  const res = await request.get<ApiResult<FinalSettleLost>>(
    '/tower/tower-contract-final-settle-lost/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加合同
 */
export async function addFinalSettleLost(data: FinalSettleLost) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-contract-final-settle-lost',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改合同
 */
export async function updateFinalSettleLost(data: FinalSettleLost) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-contract-final-settle-lost',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量修改合同
 */
export async function updateBatchFinalSettleLost(data: FinalSettleLost[]) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-contract-final-settle-lost/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
export async function addBatchFinalSettleLost(data: FinalSettleLost[]) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-contract-final-settle-lost/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除合同
 */
export async function removeFinalSettleLost(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-contract-final-settle-lost/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除合同
 */
export async function removeBatchFinalSettleLost(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-contract-final-settle-lost/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
